# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['ATPSecurityExceptionsArgs', 'ATPSecurityExceptions']

@pulumi.input_type
class ATPSecurityExceptionsArgs:
    def __init__(__self__, *,
                 bypass_urls: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None):
        """
        The set of arguments for constructing a ATPSecurityExceptions resource.
        """
        if bypass_urls is not None:
            pulumi.set(__self__, "bypass_urls", bypass_urls)

    @property
    @pulumi.getter(name="bypassUrls")
    def bypass_urls(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        return pulumi.get(self, "bypass_urls")

    @bypass_urls.setter
    def bypass_urls(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "bypass_urls", value)


@pulumi.input_type
class _ATPSecurityExceptionsState:
    def __init__(__self__, *,
                 bypass_urls: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None):
        """
        Input properties used for looking up and filtering ATPSecurityExceptions resources.
        """
        if bypass_urls is not None:
            pulumi.set(__self__, "bypass_urls", bypass_urls)

    @property
    @pulumi.getter(name="bypassUrls")
    def bypass_urls(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        return pulumi.get(self, "bypass_urls")

    @bypass_urls.setter
    def bypass_urls(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "bypass_urls", value)


@pulumi.type_token("zia:index/aTPSecurityExceptions:ATPSecurityExceptions")
class ATPSecurityExceptions(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 bypass_urls: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 __props__=None):
        """
        The **zia_atp_security_exceptions** resource alows you to updates security exceptions for the ATP policy. To learn more see [Advanced Threat Protection](https://help.zscaler.com/unified/configuring-security-exceptions-advanced-threat-protection-policy)

        ## Example Usage

        ## Import

        Zscaler offers a dedicated tool called Zscaler-Terraformer to allow the automated import of ZIA configurations into Terraform-compliant HashiCorp Configuration Language.

        Visit

        **zia_atp_security_exceptions** can be imported by using `all_urls` as the import ID.

        For example:

        ```sh
        $ pulumi import zia:index/aTPSecurityExceptions:ATPSecurityExceptions this all_urls
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[ATPSecurityExceptionsArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The **zia_atp_security_exceptions** resource alows you to updates security exceptions for the ATP policy. To learn more see [Advanced Threat Protection](https://help.zscaler.com/unified/configuring-security-exceptions-advanced-threat-protection-policy)

        ## Example Usage

        ## Import

        Zscaler offers a dedicated tool called Zscaler-Terraformer to allow the automated import of ZIA configurations into Terraform-compliant HashiCorp Configuration Language.

        Visit

        **zia_atp_security_exceptions** can be imported by using `all_urls` as the import ID.

        For example:

        ```sh
        $ pulumi import zia:index/aTPSecurityExceptions:ATPSecurityExceptions this all_urls
        ```

        :param str resource_name: The name of the resource.
        :param ATPSecurityExceptionsArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ATPSecurityExceptionsArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 bypass_urls: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ATPSecurityExceptionsArgs.__new__(ATPSecurityExceptionsArgs)

            __props__.__dict__["bypass_urls"] = bypass_urls
        super(ATPSecurityExceptions, __self__).__init__(
            'zia:index/aTPSecurityExceptions:ATPSecurityExceptions',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            bypass_urls: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None) -> 'ATPSecurityExceptions':
        """
        Get an existing ATPSecurityExceptions resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ATPSecurityExceptionsState.__new__(_ATPSecurityExceptionsState)

        __props__.__dict__["bypass_urls"] = bypass_urls
        return ATPSecurityExceptions(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="bypassUrls")
    def bypass_urls(self) -> pulumi.Output[Sequence[builtins.str]]:
        return pulumi.get(self, "bypass_urls")

