# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['DLPDictionariesArgs', 'DLPDictionaries']

@pulumi.input_type
class DLPDictionariesArgs:
    def __init__(__self__, *,
                 bin_numbers: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.int]]]] = None,
                 confidence_level_for_predefined_dict: Optional[pulumi.Input[builtins.str]] = None,
                 confidence_threshold: Optional[pulumi.Input[builtins.str]] = None,
                 custom: Optional[pulumi.Input[builtins.bool]] = None,
                 custom_phrase_match_type: Optional[pulumi.Input[builtins.str]] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 dict_template_id: Optional[pulumi.Input[builtins.int]] = None,
                 dictionary_type: Optional[pulumi.Input[builtins.str]] = None,
                 exact_data_match_details: Optional[pulumi.Input[Sequence[pulumi.Input['DLPDictionariesExactDataMatchDetailArgs']]]] = None,
                 hierarchical_identifiers: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 idm_profile_match_accuracies: Optional[pulumi.Input[Sequence[pulumi.Input['DLPDictionariesIdmProfileMatchAccuracyArgs']]]] = None,
                 ignore_exact_match_idm_dict: Optional[pulumi.Input[builtins.bool]] = None,
                 include_bin_numbers: Optional[pulumi.Input[builtins.bool]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 patterns: Optional[pulumi.Input[Sequence[pulumi.Input['DLPDictionariesPatternArgs']]]] = None,
                 phrases: Optional[pulumi.Input[Sequence[pulumi.Input['DLPDictionariesPhraseArgs']]]] = None,
                 proximity: Optional[pulumi.Input[builtins.int]] = None):
        """
        The set of arguments for constructing a DLPDictionaries resource.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.int]]] bin_numbers: The list of Bank Identification Number (BIN) values that are included or excluded from the Credit Cards dictionary. BIN
               values can be specified only for Diners Club, Mastercard, RuPay, and Visa cards. Up to 512 BIN values can be configured
               in a dictionary. Note: This field is applicable only to the predefined Credit Cards dictionary and its clones.
        :param pulumi.Input[builtins.str] confidence_level_for_predefined_dict: The DLP confidence threshold for predefined dictionaries
        :param pulumi.Input[builtins.str] confidence_threshold: The DLP confidence threshold
        :param pulumi.Input[builtins.bool] custom: The DLP dictionary proximity length.
        :param pulumi.Input[builtins.str] description: The desciption of the DLP dictionary
        :param pulumi.Input[builtins.int] dict_template_id: ID of the predefined dictionary (original source dictionary) that is used for cloning. This field is applicable only to
               cloned dictionaries. Only a limited set of identification-based predefined dictionaries (e.g., Credit Cards, Social
               Security Numbers, National Identification Numbers, etc.) can be cloned. Up to 4 clones can be created from a predefined
               dictionary.
        :param pulumi.Input[builtins.str] dictionary_type: The DLP dictionary type.
        :param pulumi.Input[Sequence[pulumi.Input['DLPDictionariesExactDataMatchDetailArgs']]] exact_data_match_details: Exact Data Match (EDM) related information for custom DLP dictionaries.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] hierarchical_identifiers: List of hierarchical identifiers for the DLP dictionary.
        :param pulumi.Input[Sequence[pulumi.Input['DLPDictionariesIdmProfileMatchAccuracyArgs']]] idm_profile_match_accuracies: List of Indexed Document Match (IDM) profiles and their corresponding match accuracy for custom DLP dictionaries.
        :param pulumi.Input[builtins.bool] ignore_exact_match_idm_dict: Indicates whether to exclude documents that are a 100% match to already-indexed documents from triggering an Indexed
               Document Match (IDM) Dictionary.
        :param pulumi.Input[builtins.bool] include_bin_numbers: A true value denotes that the specified Bank Identification Number (BIN) values are included in the Credit Cards
               dictionary. A false value denotes that the specified BIN values are excluded from the Credit Cards dictionary.Note: This
               field is applicable only to the predefined Credit Cards dictionary and its clones.
        :param pulumi.Input[builtins.str] name: The DLP dictionary's name
        :param pulumi.Input[Sequence[pulumi.Input['DLPDictionariesPatternArgs']]] patterns: List containing the patterns used within a custom DLP dictionary. This attribute is not applicable to predefined DLP
               dictionaries
        :param pulumi.Input[builtins.int] proximity: The DLP dictionary proximity length.
        """
        if bin_numbers is not None:
            pulumi.set(__self__, "bin_numbers", bin_numbers)
        if confidence_level_for_predefined_dict is not None:
            pulumi.set(__self__, "confidence_level_for_predefined_dict", confidence_level_for_predefined_dict)
        if confidence_threshold is not None:
            pulumi.set(__self__, "confidence_threshold", confidence_threshold)
        if custom is not None:
            pulumi.set(__self__, "custom", custom)
        if custom_phrase_match_type is not None:
            pulumi.set(__self__, "custom_phrase_match_type", custom_phrase_match_type)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if dict_template_id is not None:
            pulumi.set(__self__, "dict_template_id", dict_template_id)
        if dictionary_type is not None:
            pulumi.set(__self__, "dictionary_type", dictionary_type)
        if exact_data_match_details is not None:
            pulumi.set(__self__, "exact_data_match_details", exact_data_match_details)
        if hierarchical_identifiers is not None:
            pulumi.set(__self__, "hierarchical_identifiers", hierarchical_identifiers)
        if idm_profile_match_accuracies is not None:
            pulumi.set(__self__, "idm_profile_match_accuracies", idm_profile_match_accuracies)
        if ignore_exact_match_idm_dict is not None:
            pulumi.set(__self__, "ignore_exact_match_idm_dict", ignore_exact_match_idm_dict)
        if include_bin_numbers is not None:
            pulumi.set(__self__, "include_bin_numbers", include_bin_numbers)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if patterns is not None:
            pulumi.set(__self__, "patterns", patterns)
        if phrases is not None:
            pulumi.set(__self__, "phrases", phrases)
        if proximity is not None:
            pulumi.set(__self__, "proximity", proximity)

    @property
    @pulumi.getter(name="binNumbers")
    def bin_numbers(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.int]]]]:
        """
        The list of Bank Identification Number (BIN) values that are included or excluded from the Credit Cards dictionary. BIN
        values can be specified only for Diners Club, Mastercard, RuPay, and Visa cards. Up to 512 BIN values can be configured
        in a dictionary. Note: This field is applicable only to the predefined Credit Cards dictionary and its clones.
        """
        return pulumi.get(self, "bin_numbers")

    @bin_numbers.setter
    def bin_numbers(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.int]]]]):
        pulumi.set(self, "bin_numbers", value)

    @property
    @pulumi.getter(name="confidenceLevelForPredefinedDict")
    def confidence_level_for_predefined_dict(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The DLP confidence threshold for predefined dictionaries
        """
        return pulumi.get(self, "confidence_level_for_predefined_dict")

    @confidence_level_for_predefined_dict.setter
    def confidence_level_for_predefined_dict(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "confidence_level_for_predefined_dict", value)

    @property
    @pulumi.getter(name="confidenceThreshold")
    def confidence_threshold(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The DLP confidence threshold
        """
        return pulumi.get(self, "confidence_threshold")

    @confidence_threshold.setter
    def confidence_threshold(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "confidence_threshold", value)

    @property
    @pulumi.getter
    def custom(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        The DLP dictionary proximity length.
        """
        return pulumi.get(self, "custom")

    @custom.setter
    def custom(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "custom", value)

    @property
    @pulumi.getter(name="customPhraseMatchType")
    def custom_phrase_match_type(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "custom_phrase_match_type")

    @custom_phrase_match_type.setter
    def custom_phrase_match_type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "custom_phrase_match_type", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The desciption of the DLP dictionary
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="dictTemplateId")
    def dict_template_id(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        ID of the predefined dictionary (original source dictionary) that is used for cloning. This field is applicable only to
        cloned dictionaries. Only a limited set of identification-based predefined dictionaries (e.g., Credit Cards, Social
        Security Numbers, National Identification Numbers, etc.) can be cloned. Up to 4 clones can be created from a predefined
        dictionary.
        """
        return pulumi.get(self, "dict_template_id")

    @dict_template_id.setter
    def dict_template_id(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "dict_template_id", value)

    @property
    @pulumi.getter(name="dictionaryType")
    def dictionary_type(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The DLP dictionary type.
        """
        return pulumi.get(self, "dictionary_type")

    @dictionary_type.setter
    def dictionary_type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "dictionary_type", value)

    @property
    @pulumi.getter(name="exactDataMatchDetails")
    def exact_data_match_details(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['DLPDictionariesExactDataMatchDetailArgs']]]]:
        """
        Exact Data Match (EDM) related information for custom DLP dictionaries.
        """
        return pulumi.get(self, "exact_data_match_details")

    @exact_data_match_details.setter
    def exact_data_match_details(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['DLPDictionariesExactDataMatchDetailArgs']]]]):
        pulumi.set(self, "exact_data_match_details", value)

    @property
    @pulumi.getter(name="hierarchicalIdentifiers")
    def hierarchical_identifiers(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        List of hierarchical identifiers for the DLP dictionary.
        """
        return pulumi.get(self, "hierarchical_identifiers")

    @hierarchical_identifiers.setter
    def hierarchical_identifiers(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "hierarchical_identifiers", value)

    @property
    @pulumi.getter(name="idmProfileMatchAccuracies")
    def idm_profile_match_accuracies(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['DLPDictionariesIdmProfileMatchAccuracyArgs']]]]:
        """
        List of Indexed Document Match (IDM) profiles and their corresponding match accuracy for custom DLP dictionaries.
        """
        return pulumi.get(self, "idm_profile_match_accuracies")

    @idm_profile_match_accuracies.setter
    def idm_profile_match_accuracies(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['DLPDictionariesIdmProfileMatchAccuracyArgs']]]]):
        pulumi.set(self, "idm_profile_match_accuracies", value)

    @property
    @pulumi.getter(name="ignoreExactMatchIdmDict")
    def ignore_exact_match_idm_dict(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Indicates whether to exclude documents that are a 100% match to already-indexed documents from triggering an Indexed
        Document Match (IDM) Dictionary.
        """
        return pulumi.get(self, "ignore_exact_match_idm_dict")

    @ignore_exact_match_idm_dict.setter
    def ignore_exact_match_idm_dict(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "ignore_exact_match_idm_dict", value)

    @property
    @pulumi.getter(name="includeBinNumbers")
    def include_bin_numbers(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        A true value denotes that the specified Bank Identification Number (BIN) values are included in the Credit Cards
        dictionary. A false value denotes that the specified BIN values are excluded from the Credit Cards dictionary.Note: This
        field is applicable only to the predefined Credit Cards dictionary and its clones.
        """
        return pulumi.get(self, "include_bin_numbers")

    @include_bin_numbers.setter
    def include_bin_numbers(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "include_bin_numbers", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The DLP dictionary's name
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def patterns(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['DLPDictionariesPatternArgs']]]]:
        """
        List containing the patterns used within a custom DLP dictionary. This attribute is not applicable to predefined DLP
        dictionaries
        """
        return pulumi.get(self, "patterns")

    @patterns.setter
    def patterns(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['DLPDictionariesPatternArgs']]]]):
        pulumi.set(self, "patterns", value)

    @property
    @pulumi.getter
    def phrases(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['DLPDictionariesPhraseArgs']]]]:
        return pulumi.get(self, "phrases")

    @phrases.setter
    def phrases(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['DLPDictionariesPhraseArgs']]]]):
        pulumi.set(self, "phrases", value)

    @property
    @pulumi.getter
    def proximity(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        The DLP dictionary proximity length.
        """
        return pulumi.get(self, "proximity")

    @proximity.setter
    def proximity(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "proximity", value)


@pulumi.input_type
class _DLPDictionariesState:
    def __init__(__self__, *,
                 bin_numbers: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.int]]]] = None,
                 confidence_level_for_predefined_dict: Optional[pulumi.Input[builtins.str]] = None,
                 confidence_threshold: Optional[pulumi.Input[builtins.str]] = None,
                 custom: Optional[pulumi.Input[builtins.bool]] = None,
                 custom_phrase_match_type: Optional[pulumi.Input[builtins.str]] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 dict_template_id: Optional[pulumi.Input[builtins.int]] = None,
                 dictionary_id: Optional[pulumi.Input[builtins.int]] = None,
                 dictionary_type: Optional[pulumi.Input[builtins.str]] = None,
                 exact_data_match_details: Optional[pulumi.Input[Sequence[pulumi.Input['DLPDictionariesExactDataMatchDetailArgs']]]] = None,
                 hierarchical_identifiers: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 idm_profile_match_accuracies: Optional[pulumi.Input[Sequence[pulumi.Input['DLPDictionariesIdmProfileMatchAccuracyArgs']]]] = None,
                 ignore_exact_match_idm_dict: Optional[pulumi.Input[builtins.bool]] = None,
                 include_bin_numbers: Optional[pulumi.Input[builtins.bool]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 patterns: Optional[pulumi.Input[Sequence[pulumi.Input['DLPDictionariesPatternArgs']]]] = None,
                 phrases: Optional[pulumi.Input[Sequence[pulumi.Input['DLPDictionariesPhraseArgs']]]] = None,
                 proximity: Optional[pulumi.Input[builtins.int]] = None):
        """
        Input properties used for looking up and filtering DLPDictionaries resources.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.int]]] bin_numbers: The list of Bank Identification Number (BIN) values that are included or excluded from the Credit Cards dictionary. BIN
               values can be specified only for Diners Club, Mastercard, RuPay, and Visa cards. Up to 512 BIN values can be configured
               in a dictionary. Note: This field is applicable only to the predefined Credit Cards dictionary and its clones.
        :param pulumi.Input[builtins.str] confidence_level_for_predefined_dict: The DLP confidence threshold for predefined dictionaries
        :param pulumi.Input[builtins.str] confidence_threshold: The DLP confidence threshold
        :param pulumi.Input[builtins.bool] custom: The DLP dictionary proximity length.
        :param pulumi.Input[builtins.str] description: The desciption of the DLP dictionary
        :param pulumi.Input[builtins.int] dict_template_id: ID of the predefined dictionary (original source dictionary) that is used for cloning. This field is applicable only to
               cloned dictionaries. Only a limited set of identification-based predefined dictionaries (e.g., Credit Cards, Social
               Security Numbers, National Identification Numbers, etc.) can be cloned. Up to 4 clones can be created from a predefined
               dictionary.
        :param pulumi.Input[builtins.str] dictionary_type: The DLP dictionary type.
        :param pulumi.Input[Sequence[pulumi.Input['DLPDictionariesExactDataMatchDetailArgs']]] exact_data_match_details: Exact Data Match (EDM) related information for custom DLP dictionaries.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] hierarchical_identifiers: List of hierarchical identifiers for the DLP dictionary.
        :param pulumi.Input[Sequence[pulumi.Input['DLPDictionariesIdmProfileMatchAccuracyArgs']]] idm_profile_match_accuracies: List of Indexed Document Match (IDM) profiles and their corresponding match accuracy for custom DLP dictionaries.
        :param pulumi.Input[builtins.bool] ignore_exact_match_idm_dict: Indicates whether to exclude documents that are a 100% match to already-indexed documents from triggering an Indexed
               Document Match (IDM) Dictionary.
        :param pulumi.Input[builtins.bool] include_bin_numbers: A true value denotes that the specified Bank Identification Number (BIN) values are included in the Credit Cards
               dictionary. A false value denotes that the specified BIN values are excluded from the Credit Cards dictionary.Note: This
               field is applicable only to the predefined Credit Cards dictionary and its clones.
        :param pulumi.Input[builtins.str] name: The DLP dictionary's name
        :param pulumi.Input[Sequence[pulumi.Input['DLPDictionariesPatternArgs']]] patterns: List containing the patterns used within a custom DLP dictionary. This attribute is not applicable to predefined DLP
               dictionaries
        :param pulumi.Input[builtins.int] proximity: The DLP dictionary proximity length.
        """
        if bin_numbers is not None:
            pulumi.set(__self__, "bin_numbers", bin_numbers)
        if confidence_level_for_predefined_dict is not None:
            pulumi.set(__self__, "confidence_level_for_predefined_dict", confidence_level_for_predefined_dict)
        if confidence_threshold is not None:
            pulumi.set(__self__, "confidence_threshold", confidence_threshold)
        if custom is not None:
            pulumi.set(__self__, "custom", custom)
        if custom_phrase_match_type is not None:
            pulumi.set(__self__, "custom_phrase_match_type", custom_phrase_match_type)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if dict_template_id is not None:
            pulumi.set(__self__, "dict_template_id", dict_template_id)
        if dictionary_id is not None:
            pulumi.set(__self__, "dictionary_id", dictionary_id)
        if dictionary_type is not None:
            pulumi.set(__self__, "dictionary_type", dictionary_type)
        if exact_data_match_details is not None:
            pulumi.set(__self__, "exact_data_match_details", exact_data_match_details)
        if hierarchical_identifiers is not None:
            pulumi.set(__self__, "hierarchical_identifiers", hierarchical_identifiers)
        if idm_profile_match_accuracies is not None:
            pulumi.set(__self__, "idm_profile_match_accuracies", idm_profile_match_accuracies)
        if ignore_exact_match_idm_dict is not None:
            pulumi.set(__self__, "ignore_exact_match_idm_dict", ignore_exact_match_idm_dict)
        if include_bin_numbers is not None:
            pulumi.set(__self__, "include_bin_numbers", include_bin_numbers)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if patterns is not None:
            pulumi.set(__self__, "patterns", patterns)
        if phrases is not None:
            pulumi.set(__self__, "phrases", phrases)
        if proximity is not None:
            pulumi.set(__self__, "proximity", proximity)

    @property
    @pulumi.getter(name="binNumbers")
    def bin_numbers(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.int]]]]:
        """
        The list of Bank Identification Number (BIN) values that are included or excluded from the Credit Cards dictionary. BIN
        values can be specified only for Diners Club, Mastercard, RuPay, and Visa cards. Up to 512 BIN values can be configured
        in a dictionary. Note: This field is applicable only to the predefined Credit Cards dictionary and its clones.
        """
        return pulumi.get(self, "bin_numbers")

    @bin_numbers.setter
    def bin_numbers(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.int]]]]):
        pulumi.set(self, "bin_numbers", value)

    @property
    @pulumi.getter(name="confidenceLevelForPredefinedDict")
    def confidence_level_for_predefined_dict(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The DLP confidence threshold for predefined dictionaries
        """
        return pulumi.get(self, "confidence_level_for_predefined_dict")

    @confidence_level_for_predefined_dict.setter
    def confidence_level_for_predefined_dict(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "confidence_level_for_predefined_dict", value)

    @property
    @pulumi.getter(name="confidenceThreshold")
    def confidence_threshold(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The DLP confidence threshold
        """
        return pulumi.get(self, "confidence_threshold")

    @confidence_threshold.setter
    def confidence_threshold(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "confidence_threshold", value)

    @property
    @pulumi.getter
    def custom(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        The DLP dictionary proximity length.
        """
        return pulumi.get(self, "custom")

    @custom.setter
    def custom(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "custom", value)

    @property
    @pulumi.getter(name="customPhraseMatchType")
    def custom_phrase_match_type(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "custom_phrase_match_type")

    @custom_phrase_match_type.setter
    def custom_phrase_match_type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "custom_phrase_match_type", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The desciption of the DLP dictionary
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="dictTemplateId")
    def dict_template_id(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        ID of the predefined dictionary (original source dictionary) that is used for cloning. This field is applicable only to
        cloned dictionaries. Only a limited set of identification-based predefined dictionaries (e.g., Credit Cards, Social
        Security Numbers, National Identification Numbers, etc.) can be cloned. Up to 4 clones can be created from a predefined
        dictionary.
        """
        return pulumi.get(self, "dict_template_id")

    @dict_template_id.setter
    def dict_template_id(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "dict_template_id", value)

    @property
    @pulumi.getter(name="dictionaryId")
    def dictionary_id(self) -> Optional[pulumi.Input[builtins.int]]:
        return pulumi.get(self, "dictionary_id")

    @dictionary_id.setter
    def dictionary_id(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "dictionary_id", value)

    @property
    @pulumi.getter(name="dictionaryType")
    def dictionary_type(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The DLP dictionary type.
        """
        return pulumi.get(self, "dictionary_type")

    @dictionary_type.setter
    def dictionary_type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "dictionary_type", value)

    @property
    @pulumi.getter(name="exactDataMatchDetails")
    def exact_data_match_details(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['DLPDictionariesExactDataMatchDetailArgs']]]]:
        """
        Exact Data Match (EDM) related information for custom DLP dictionaries.
        """
        return pulumi.get(self, "exact_data_match_details")

    @exact_data_match_details.setter
    def exact_data_match_details(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['DLPDictionariesExactDataMatchDetailArgs']]]]):
        pulumi.set(self, "exact_data_match_details", value)

    @property
    @pulumi.getter(name="hierarchicalIdentifiers")
    def hierarchical_identifiers(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        List of hierarchical identifiers for the DLP dictionary.
        """
        return pulumi.get(self, "hierarchical_identifiers")

    @hierarchical_identifiers.setter
    def hierarchical_identifiers(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "hierarchical_identifiers", value)

    @property
    @pulumi.getter(name="idmProfileMatchAccuracies")
    def idm_profile_match_accuracies(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['DLPDictionariesIdmProfileMatchAccuracyArgs']]]]:
        """
        List of Indexed Document Match (IDM) profiles and their corresponding match accuracy for custom DLP dictionaries.
        """
        return pulumi.get(self, "idm_profile_match_accuracies")

    @idm_profile_match_accuracies.setter
    def idm_profile_match_accuracies(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['DLPDictionariesIdmProfileMatchAccuracyArgs']]]]):
        pulumi.set(self, "idm_profile_match_accuracies", value)

    @property
    @pulumi.getter(name="ignoreExactMatchIdmDict")
    def ignore_exact_match_idm_dict(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Indicates whether to exclude documents that are a 100% match to already-indexed documents from triggering an Indexed
        Document Match (IDM) Dictionary.
        """
        return pulumi.get(self, "ignore_exact_match_idm_dict")

    @ignore_exact_match_idm_dict.setter
    def ignore_exact_match_idm_dict(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "ignore_exact_match_idm_dict", value)

    @property
    @pulumi.getter(name="includeBinNumbers")
    def include_bin_numbers(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        A true value denotes that the specified Bank Identification Number (BIN) values are included in the Credit Cards
        dictionary. A false value denotes that the specified BIN values are excluded from the Credit Cards dictionary.Note: This
        field is applicable only to the predefined Credit Cards dictionary and its clones.
        """
        return pulumi.get(self, "include_bin_numbers")

    @include_bin_numbers.setter
    def include_bin_numbers(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "include_bin_numbers", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The DLP dictionary's name
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def patterns(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['DLPDictionariesPatternArgs']]]]:
        """
        List containing the patterns used within a custom DLP dictionary. This attribute is not applicable to predefined DLP
        dictionaries
        """
        return pulumi.get(self, "patterns")

    @patterns.setter
    def patterns(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['DLPDictionariesPatternArgs']]]]):
        pulumi.set(self, "patterns", value)

    @property
    @pulumi.getter
    def phrases(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['DLPDictionariesPhraseArgs']]]]:
        return pulumi.get(self, "phrases")

    @phrases.setter
    def phrases(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['DLPDictionariesPhraseArgs']]]]):
        pulumi.set(self, "phrases", value)

    @property
    @pulumi.getter
    def proximity(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        The DLP dictionary proximity length.
        """
        return pulumi.get(self, "proximity")

    @proximity.setter
    def proximity(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "proximity", value)


@pulumi.type_token("zia:index/dLPDictionaries:DLPDictionaries")
class DLPDictionaries(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 bin_numbers: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.int]]]] = None,
                 confidence_level_for_predefined_dict: Optional[pulumi.Input[builtins.str]] = None,
                 confidence_threshold: Optional[pulumi.Input[builtins.str]] = None,
                 custom: Optional[pulumi.Input[builtins.bool]] = None,
                 custom_phrase_match_type: Optional[pulumi.Input[builtins.str]] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 dict_template_id: Optional[pulumi.Input[builtins.int]] = None,
                 dictionary_type: Optional[pulumi.Input[builtins.str]] = None,
                 exact_data_match_details: Optional[pulumi.Input[Sequence[pulumi.Input[Union['DLPDictionariesExactDataMatchDetailArgs', 'DLPDictionariesExactDataMatchDetailArgsDict']]]]] = None,
                 hierarchical_identifiers: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 idm_profile_match_accuracies: Optional[pulumi.Input[Sequence[pulumi.Input[Union['DLPDictionariesIdmProfileMatchAccuracyArgs', 'DLPDictionariesIdmProfileMatchAccuracyArgsDict']]]]] = None,
                 ignore_exact_match_idm_dict: Optional[pulumi.Input[builtins.bool]] = None,
                 include_bin_numbers: Optional[pulumi.Input[builtins.bool]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 patterns: Optional[pulumi.Input[Sequence[pulumi.Input[Union['DLPDictionariesPatternArgs', 'DLPDictionariesPatternArgsDict']]]]] = None,
                 phrases: Optional[pulumi.Input[Sequence[pulumi.Input[Union['DLPDictionariesPhraseArgs', 'DLPDictionariesPhraseArgsDict']]]]] = None,
                 proximity: Optional[pulumi.Input[builtins.int]] = None,
                 __props__=None):
        """
        The **zia_dlp_dictionaries** resource allows the creation and management of ZIA DLP dictionaries in the Zscaler Internet Access cloud or via the API.

        ## Example Usage

        ### With Hierarchical Identifiers

        ## Import

        Zscaler offers a dedicated tool called Zscaler-Terraformer to allow the automated import of ZIA configurations into Terraform-compliant HashiCorp Configuration Language.

        Visit

        **zia_dlp_dictionaries** can be imported by using `<DICTIONARY ID>` or `<DICTIONARY_NAME>` as the import ID.

        For example:

        ```sh
        $ pulumi import zia:index/dLPDictionaries:DLPDictionaries example <dictionary_id>
        ```

        or

        ```sh
        $ pulumi import zia:index/dLPDictionaries:DLPDictionaries example <dictionary_name>
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.int]]] bin_numbers: The list of Bank Identification Number (BIN) values that are included or excluded from the Credit Cards dictionary. BIN
               values can be specified only for Diners Club, Mastercard, RuPay, and Visa cards. Up to 512 BIN values can be configured
               in a dictionary. Note: This field is applicable only to the predefined Credit Cards dictionary and its clones.
        :param pulumi.Input[builtins.str] confidence_level_for_predefined_dict: The DLP confidence threshold for predefined dictionaries
        :param pulumi.Input[builtins.str] confidence_threshold: The DLP confidence threshold
        :param pulumi.Input[builtins.bool] custom: The DLP dictionary proximity length.
        :param pulumi.Input[builtins.str] description: The desciption of the DLP dictionary
        :param pulumi.Input[builtins.int] dict_template_id: ID of the predefined dictionary (original source dictionary) that is used for cloning. This field is applicable only to
               cloned dictionaries. Only a limited set of identification-based predefined dictionaries (e.g., Credit Cards, Social
               Security Numbers, National Identification Numbers, etc.) can be cloned. Up to 4 clones can be created from a predefined
               dictionary.
        :param pulumi.Input[builtins.str] dictionary_type: The DLP dictionary type.
        :param pulumi.Input[Sequence[pulumi.Input[Union['DLPDictionariesExactDataMatchDetailArgs', 'DLPDictionariesExactDataMatchDetailArgsDict']]]] exact_data_match_details: Exact Data Match (EDM) related information for custom DLP dictionaries.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] hierarchical_identifiers: List of hierarchical identifiers for the DLP dictionary.
        :param pulumi.Input[Sequence[pulumi.Input[Union['DLPDictionariesIdmProfileMatchAccuracyArgs', 'DLPDictionariesIdmProfileMatchAccuracyArgsDict']]]] idm_profile_match_accuracies: List of Indexed Document Match (IDM) profiles and their corresponding match accuracy for custom DLP dictionaries.
        :param pulumi.Input[builtins.bool] ignore_exact_match_idm_dict: Indicates whether to exclude documents that are a 100% match to already-indexed documents from triggering an Indexed
               Document Match (IDM) Dictionary.
        :param pulumi.Input[builtins.bool] include_bin_numbers: A true value denotes that the specified Bank Identification Number (BIN) values are included in the Credit Cards
               dictionary. A false value denotes that the specified BIN values are excluded from the Credit Cards dictionary.Note: This
               field is applicable only to the predefined Credit Cards dictionary and its clones.
        :param pulumi.Input[builtins.str] name: The DLP dictionary's name
        :param pulumi.Input[Sequence[pulumi.Input[Union['DLPDictionariesPatternArgs', 'DLPDictionariesPatternArgsDict']]]] patterns: List containing the patterns used within a custom DLP dictionary. This attribute is not applicable to predefined DLP
               dictionaries
        :param pulumi.Input[builtins.int] proximity: The DLP dictionary proximity length.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[DLPDictionariesArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The **zia_dlp_dictionaries** resource allows the creation and management of ZIA DLP dictionaries in the Zscaler Internet Access cloud or via the API.

        ## Example Usage

        ### With Hierarchical Identifiers

        ## Import

        Zscaler offers a dedicated tool called Zscaler-Terraformer to allow the automated import of ZIA configurations into Terraform-compliant HashiCorp Configuration Language.

        Visit

        **zia_dlp_dictionaries** can be imported by using `<DICTIONARY ID>` or `<DICTIONARY_NAME>` as the import ID.

        For example:

        ```sh
        $ pulumi import zia:index/dLPDictionaries:DLPDictionaries example <dictionary_id>
        ```

        or

        ```sh
        $ pulumi import zia:index/dLPDictionaries:DLPDictionaries example <dictionary_name>
        ```

        :param str resource_name: The name of the resource.
        :param DLPDictionariesArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DLPDictionariesArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 bin_numbers: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.int]]]] = None,
                 confidence_level_for_predefined_dict: Optional[pulumi.Input[builtins.str]] = None,
                 confidence_threshold: Optional[pulumi.Input[builtins.str]] = None,
                 custom: Optional[pulumi.Input[builtins.bool]] = None,
                 custom_phrase_match_type: Optional[pulumi.Input[builtins.str]] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 dict_template_id: Optional[pulumi.Input[builtins.int]] = None,
                 dictionary_type: Optional[pulumi.Input[builtins.str]] = None,
                 exact_data_match_details: Optional[pulumi.Input[Sequence[pulumi.Input[Union['DLPDictionariesExactDataMatchDetailArgs', 'DLPDictionariesExactDataMatchDetailArgsDict']]]]] = None,
                 hierarchical_identifiers: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 idm_profile_match_accuracies: Optional[pulumi.Input[Sequence[pulumi.Input[Union['DLPDictionariesIdmProfileMatchAccuracyArgs', 'DLPDictionariesIdmProfileMatchAccuracyArgsDict']]]]] = None,
                 ignore_exact_match_idm_dict: Optional[pulumi.Input[builtins.bool]] = None,
                 include_bin_numbers: Optional[pulumi.Input[builtins.bool]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 patterns: Optional[pulumi.Input[Sequence[pulumi.Input[Union['DLPDictionariesPatternArgs', 'DLPDictionariesPatternArgsDict']]]]] = None,
                 phrases: Optional[pulumi.Input[Sequence[pulumi.Input[Union['DLPDictionariesPhraseArgs', 'DLPDictionariesPhraseArgsDict']]]]] = None,
                 proximity: Optional[pulumi.Input[builtins.int]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DLPDictionariesArgs.__new__(DLPDictionariesArgs)

            __props__.__dict__["bin_numbers"] = bin_numbers
            __props__.__dict__["confidence_level_for_predefined_dict"] = confidence_level_for_predefined_dict
            __props__.__dict__["confidence_threshold"] = confidence_threshold
            __props__.__dict__["custom"] = custom
            __props__.__dict__["custom_phrase_match_type"] = custom_phrase_match_type
            __props__.__dict__["description"] = description
            __props__.__dict__["dict_template_id"] = dict_template_id
            __props__.__dict__["dictionary_type"] = dictionary_type
            __props__.__dict__["exact_data_match_details"] = exact_data_match_details
            __props__.__dict__["hierarchical_identifiers"] = hierarchical_identifiers
            __props__.__dict__["idm_profile_match_accuracies"] = idm_profile_match_accuracies
            __props__.__dict__["ignore_exact_match_idm_dict"] = ignore_exact_match_idm_dict
            __props__.__dict__["include_bin_numbers"] = include_bin_numbers
            __props__.__dict__["name"] = name
            __props__.__dict__["patterns"] = patterns
            __props__.__dict__["phrases"] = phrases
            __props__.__dict__["proximity"] = proximity
            __props__.__dict__["dictionary_id"] = None
        super(DLPDictionaries, __self__).__init__(
            'zia:index/dLPDictionaries:DLPDictionaries',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            bin_numbers: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.int]]]] = None,
            confidence_level_for_predefined_dict: Optional[pulumi.Input[builtins.str]] = None,
            confidence_threshold: Optional[pulumi.Input[builtins.str]] = None,
            custom: Optional[pulumi.Input[builtins.bool]] = None,
            custom_phrase_match_type: Optional[pulumi.Input[builtins.str]] = None,
            description: Optional[pulumi.Input[builtins.str]] = None,
            dict_template_id: Optional[pulumi.Input[builtins.int]] = None,
            dictionary_id: Optional[pulumi.Input[builtins.int]] = None,
            dictionary_type: Optional[pulumi.Input[builtins.str]] = None,
            exact_data_match_details: Optional[pulumi.Input[Sequence[pulumi.Input[Union['DLPDictionariesExactDataMatchDetailArgs', 'DLPDictionariesExactDataMatchDetailArgsDict']]]]] = None,
            hierarchical_identifiers: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
            idm_profile_match_accuracies: Optional[pulumi.Input[Sequence[pulumi.Input[Union['DLPDictionariesIdmProfileMatchAccuracyArgs', 'DLPDictionariesIdmProfileMatchAccuracyArgsDict']]]]] = None,
            ignore_exact_match_idm_dict: Optional[pulumi.Input[builtins.bool]] = None,
            include_bin_numbers: Optional[pulumi.Input[builtins.bool]] = None,
            name: Optional[pulumi.Input[builtins.str]] = None,
            patterns: Optional[pulumi.Input[Sequence[pulumi.Input[Union['DLPDictionariesPatternArgs', 'DLPDictionariesPatternArgsDict']]]]] = None,
            phrases: Optional[pulumi.Input[Sequence[pulumi.Input[Union['DLPDictionariesPhraseArgs', 'DLPDictionariesPhraseArgsDict']]]]] = None,
            proximity: Optional[pulumi.Input[builtins.int]] = None) -> 'DLPDictionaries':
        """
        Get an existing DLPDictionaries resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.int]]] bin_numbers: The list of Bank Identification Number (BIN) values that are included or excluded from the Credit Cards dictionary. BIN
               values can be specified only for Diners Club, Mastercard, RuPay, and Visa cards. Up to 512 BIN values can be configured
               in a dictionary. Note: This field is applicable only to the predefined Credit Cards dictionary and its clones.
        :param pulumi.Input[builtins.str] confidence_level_for_predefined_dict: The DLP confidence threshold for predefined dictionaries
        :param pulumi.Input[builtins.str] confidence_threshold: The DLP confidence threshold
        :param pulumi.Input[builtins.bool] custom: The DLP dictionary proximity length.
        :param pulumi.Input[builtins.str] description: The desciption of the DLP dictionary
        :param pulumi.Input[builtins.int] dict_template_id: ID of the predefined dictionary (original source dictionary) that is used for cloning. This field is applicable only to
               cloned dictionaries. Only a limited set of identification-based predefined dictionaries (e.g., Credit Cards, Social
               Security Numbers, National Identification Numbers, etc.) can be cloned. Up to 4 clones can be created from a predefined
               dictionary.
        :param pulumi.Input[builtins.str] dictionary_type: The DLP dictionary type.
        :param pulumi.Input[Sequence[pulumi.Input[Union['DLPDictionariesExactDataMatchDetailArgs', 'DLPDictionariesExactDataMatchDetailArgsDict']]]] exact_data_match_details: Exact Data Match (EDM) related information for custom DLP dictionaries.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] hierarchical_identifiers: List of hierarchical identifiers for the DLP dictionary.
        :param pulumi.Input[Sequence[pulumi.Input[Union['DLPDictionariesIdmProfileMatchAccuracyArgs', 'DLPDictionariesIdmProfileMatchAccuracyArgsDict']]]] idm_profile_match_accuracies: List of Indexed Document Match (IDM) profiles and their corresponding match accuracy for custom DLP dictionaries.
        :param pulumi.Input[builtins.bool] ignore_exact_match_idm_dict: Indicates whether to exclude documents that are a 100% match to already-indexed documents from triggering an Indexed
               Document Match (IDM) Dictionary.
        :param pulumi.Input[builtins.bool] include_bin_numbers: A true value denotes that the specified Bank Identification Number (BIN) values are included in the Credit Cards
               dictionary. A false value denotes that the specified BIN values are excluded from the Credit Cards dictionary.Note: This
               field is applicable only to the predefined Credit Cards dictionary and its clones.
        :param pulumi.Input[builtins.str] name: The DLP dictionary's name
        :param pulumi.Input[Sequence[pulumi.Input[Union['DLPDictionariesPatternArgs', 'DLPDictionariesPatternArgsDict']]]] patterns: List containing the patterns used within a custom DLP dictionary. This attribute is not applicable to predefined DLP
               dictionaries
        :param pulumi.Input[builtins.int] proximity: The DLP dictionary proximity length.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _DLPDictionariesState.__new__(_DLPDictionariesState)

        __props__.__dict__["bin_numbers"] = bin_numbers
        __props__.__dict__["confidence_level_for_predefined_dict"] = confidence_level_for_predefined_dict
        __props__.__dict__["confidence_threshold"] = confidence_threshold
        __props__.__dict__["custom"] = custom
        __props__.__dict__["custom_phrase_match_type"] = custom_phrase_match_type
        __props__.__dict__["description"] = description
        __props__.__dict__["dict_template_id"] = dict_template_id
        __props__.__dict__["dictionary_id"] = dictionary_id
        __props__.__dict__["dictionary_type"] = dictionary_type
        __props__.__dict__["exact_data_match_details"] = exact_data_match_details
        __props__.__dict__["hierarchical_identifiers"] = hierarchical_identifiers
        __props__.__dict__["idm_profile_match_accuracies"] = idm_profile_match_accuracies
        __props__.__dict__["ignore_exact_match_idm_dict"] = ignore_exact_match_idm_dict
        __props__.__dict__["include_bin_numbers"] = include_bin_numbers
        __props__.__dict__["name"] = name
        __props__.__dict__["patterns"] = patterns
        __props__.__dict__["phrases"] = phrases
        __props__.__dict__["proximity"] = proximity
        return DLPDictionaries(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="binNumbers")
    def bin_numbers(self) -> pulumi.Output[Optional[Sequence[builtins.int]]]:
        """
        The list of Bank Identification Number (BIN) values that are included or excluded from the Credit Cards dictionary. BIN
        values can be specified only for Diners Club, Mastercard, RuPay, and Visa cards. Up to 512 BIN values can be configured
        in a dictionary. Note: This field is applicable only to the predefined Credit Cards dictionary and its clones.
        """
        return pulumi.get(self, "bin_numbers")

    @property
    @pulumi.getter(name="confidenceLevelForPredefinedDict")
    def confidence_level_for_predefined_dict(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The DLP confidence threshold for predefined dictionaries
        """
        return pulumi.get(self, "confidence_level_for_predefined_dict")

    @property
    @pulumi.getter(name="confidenceThreshold")
    def confidence_threshold(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The DLP confidence threshold
        """
        return pulumi.get(self, "confidence_threshold")

    @property
    @pulumi.getter
    def custom(self) -> pulumi.Output[builtins.bool]:
        """
        The DLP dictionary proximity length.
        """
        return pulumi.get(self, "custom")

    @property
    @pulumi.getter(name="customPhraseMatchType")
    def custom_phrase_match_type(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "custom_phrase_match_type")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The desciption of the DLP dictionary
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="dictTemplateId")
    def dict_template_id(self) -> pulumi.Output[Optional[builtins.int]]:
        """
        ID of the predefined dictionary (original source dictionary) that is used for cloning. This field is applicable only to
        cloned dictionaries. Only a limited set of identification-based predefined dictionaries (e.g., Credit Cards, Social
        Security Numbers, National Identification Numbers, etc.) can be cloned. Up to 4 clones can be created from a predefined
        dictionary.
        """
        return pulumi.get(self, "dict_template_id")

    @property
    @pulumi.getter(name="dictionaryId")
    def dictionary_id(self) -> pulumi.Output[builtins.int]:
        return pulumi.get(self, "dictionary_id")

    @property
    @pulumi.getter(name="dictionaryType")
    def dictionary_type(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The DLP dictionary type.
        """
        return pulumi.get(self, "dictionary_type")

    @property
    @pulumi.getter(name="exactDataMatchDetails")
    def exact_data_match_details(self) -> pulumi.Output[Optional[Sequence['outputs.DLPDictionariesExactDataMatchDetail']]]:
        """
        Exact Data Match (EDM) related information for custom DLP dictionaries.
        """
        return pulumi.get(self, "exact_data_match_details")

    @property
    @pulumi.getter(name="hierarchicalIdentifiers")
    def hierarchical_identifiers(self) -> pulumi.Output[Optional[Sequence[builtins.str]]]:
        """
        List of hierarchical identifiers for the DLP dictionary.
        """
        return pulumi.get(self, "hierarchical_identifiers")

    @property
    @pulumi.getter(name="idmProfileMatchAccuracies")
    def idm_profile_match_accuracies(self) -> pulumi.Output[Sequence['outputs.DLPDictionariesIdmProfileMatchAccuracy']]:
        """
        List of Indexed Document Match (IDM) profiles and their corresponding match accuracy for custom DLP dictionaries.
        """
        return pulumi.get(self, "idm_profile_match_accuracies")

    @property
    @pulumi.getter(name="ignoreExactMatchIdmDict")
    def ignore_exact_match_idm_dict(self) -> pulumi.Output[Optional[builtins.bool]]:
        """
        Indicates whether to exclude documents that are a 100% match to already-indexed documents from triggering an Indexed
        Document Match (IDM) Dictionary.
        """
        return pulumi.get(self, "ignore_exact_match_idm_dict")

    @property
    @pulumi.getter(name="includeBinNumbers")
    def include_bin_numbers(self) -> pulumi.Output[builtins.bool]:
        """
        A true value denotes that the specified Bank Identification Number (BIN) values are included in the Credit Cards
        dictionary. A false value denotes that the specified BIN values are excluded from the Credit Cards dictionary.Note: This
        field is applicable only to the predefined Credit Cards dictionary and its clones.
        """
        return pulumi.get(self, "include_bin_numbers")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        The DLP dictionary's name
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def patterns(self) -> pulumi.Output[Sequence['outputs.DLPDictionariesPattern']]:
        """
        List containing the patterns used within a custom DLP dictionary. This attribute is not applicable to predefined DLP
        dictionaries
        """
        return pulumi.get(self, "patterns")

    @property
    @pulumi.getter
    def phrases(self) -> pulumi.Output[Sequence['outputs.DLPDictionariesPhrase']]:
        return pulumi.get(self, "phrases")

    @property
    @pulumi.getter
    def proximity(self) -> pulumi.Output[Optional[builtins.int]]:
        """
        The DLP dictionary proximity length.
        """
        return pulumi.get(self, "proximity")

