# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = [
    'GetAuthSettingsURLsResult',
    'AwaitableGetAuthSettingsURLsResult',
    'get_auth_settings_urls',
    'get_auth_settings_urls_output',
]

@pulumi.output_type
class GetAuthSettingsURLsResult:
    """
    A collection of values returned by getAuthSettingsURLs.
    """
    def __init__(__self__, id=None, urls=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if urls and not isinstance(urls, list):
            raise TypeError("Expected argument 'urls' to be a list")
        pulumi.set(__self__, "urls", urls)

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def urls(self) -> Sequence[builtins.str]:
        return pulumi.get(self, "urls")


class AwaitableGetAuthSettingsURLsResult(GetAuthSettingsURLsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAuthSettingsURLsResult(
            id=self.id,
            urls=self.urls)


def get_auth_settings_urls(opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAuthSettingsURLsResult:
    """
    Use the **zia_auth_settings_urls** data source to get a list of URLs that were exempted from cookie authentiation and SSL Inspection in the Zscaler Internet Access cloud or via the API. To learn more see [URL Format Guidelines](https://help.zscaler.com/zia/url-format-guidelines)

    ## Example Usage
    """
    __args__ = dict()
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('zia:index/getAuthSettingsURLs:getAuthSettingsURLs', __args__, opts=opts, typ=GetAuthSettingsURLsResult).value

    return AwaitableGetAuthSettingsURLsResult(
        id=pulumi.get(__ret__, 'id'),
        urls=pulumi.get(__ret__, 'urls'))
def get_auth_settings_urls_output(opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetAuthSettingsURLsResult]:
    """
    Use the **zia_auth_settings_urls** data source to get a list of URLs that were exempted from cookie authentiation and SSL Inspection in the Zscaler Internet Access cloud or via the API. To learn more see [URL Format Guidelines](https://help.zscaler.com/zia/url-format-guidelines)

    ## Example Usage
    """
    __args__ = dict()
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('zia:index/getAuthSettingsURLs:getAuthSettingsURLs', __args__, opts=opts, typ=GetAuthSettingsURLsResult)
    return __ret__.apply(lambda __response__: GetAuthSettingsURLsResult(
        id=pulumi.get(__response__, 'id'),
        urls=pulumi.get(__response__, 'urls')))
