# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = [
    'GetDepartmentManagementResult',
    'AwaitableGetDepartmentManagementResult',
    'get_department_management',
    'get_department_management_output',
]

@pulumi.output_type
class GetDepartmentManagementResult:
    """
    A collection of values returned by getDepartmentManagement.
    """
    def __init__(__self__, comments=None, deleted=None, id=None, idp_id=None, name=None):
        if comments and not isinstance(comments, str):
            raise TypeError("Expected argument 'comments' to be a str")
        pulumi.set(__self__, "comments", comments)
        if deleted and not isinstance(deleted, bool):
            raise TypeError("Expected argument 'deleted' to be a bool")
        pulumi.set(__self__, "deleted", deleted)
        if id and not isinstance(id, int):
            raise TypeError("Expected argument 'id' to be a int")
        pulumi.set(__self__, "id", id)
        if idp_id and not isinstance(idp_id, int):
            raise TypeError("Expected argument 'idp_id' to be a int")
        pulumi.set(__self__, "idp_id", idp_id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def comments(self) -> builtins.str:
        """
        (Optional) Additional information about this department
        """
        return pulumi.get(self, "comments")

    @property
    @pulumi.getter
    def deleted(self) -> builtins.bool:
        """
        (Boolean) default: false
        """
        return pulumi.get(self, "deleted")

    @property
    @pulumi.getter
    def id(self) -> builtins.int:
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="idpId")
    def idp_id(self) -> builtins.int:
        """
        (Optional) Unique identfier for the identity provider (IdP)
        """
        return pulumi.get(self, "idp_id")

    @property
    @pulumi.getter
    def name(self) -> Optional[builtins.str]:
        return pulumi.get(self, "name")


class AwaitableGetDepartmentManagementResult(GetDepartmentManagementResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDepartmentManagementResult(
            comments=self.comments,
            deleted=self.deleted,
            id=self.id,
            idp_id=self.idp_id,
            name=self.name)


def get_department_management(name: Optional[builtins.str] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDepartmentManagementResult:
    """
    Use the **zia_department_management** data source to get information about user department created in the Zscaler Internet Access cloud or via the API. This data source can then be associated with several ZIA resources such as: URL filtering rules, Cloud Firewall rules, and locations.

    ## Example Usage


    :param builtins.str name: Name of the user department
    """
    __args__ = dict()
    __args__['name'] = name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('zia:index/getDepartmentManagement:getDepartmentManagement', __args__, opts=opts, typ=GetDepartmentManagementResult).value

    return AwaitableGetDepartmentManagementResult(
        comments=pulumi.get(__ret__, 'comments'),
        deleted=pulumi.get(__ret__, 'deleted'),
        id=pulumi.get(__ret__, 'id'),
        idp_id=pulumi.get(__ret__, 'idp_id'),
        name=pulumi.get(__ret__, 'name'))
def get_department_management_output(name: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                     opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetDepartmentManagementResult]:
    """
    Use the **zia_department_management** data source to get information about user department created in the Zscaler Internet Access cloud or via the API. This data source can then be associated with several ZIA resources such as: URL filtering rules, Cloud Firewall rules, and locations.

    ## Example Usage


    :param builtins.str name: Name of the user department
    """
    __args__ = dict()
    __args__['name'] = name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('zia:index/getDepartmentManagement:getDepartmentManagement', __args__, opts=opts, typ=GetDepartmentManagementResult)
    return __ret__.apply(lambda __response__: GetDepartmentManagementResult(
        comments=pulumi.get(__response__, 'comments'),
        deleted=pulumi.get(__response__, 'deleted'),
        id=pulumi.get(__response__, 'id'),
        idp_id=pulumi.get(__response__, 'idp_id'),
        name=pulumi.get(__response__, 'name')))
