# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['ATPMalwarePolicyArgs', 'ATPMalwarePolicy']

@pulumi.input_type
class ATPMalwarePolicyArgs:
    def __init__(__self__, *,
                 block_password_protected_archive_files: Optional[pulumi.Input[builtins.bool]] = None,
                 block_unscannable_files: Optional[pulumi.Input[builtins.bool]] = None):
        """
        The set of arguments for constructing a ATPMalwarePolicy resource.
        :param pulumi.Input[builtins.bool] block_password_protected_archive_files: A Boolean value indicating whether to allow or block users from uploading or downloading password-protected files
        :param pulumi.Input[builtins.bool] block_unscannable_files: A Boolean value indicating whether to allow or block users from uploading or downloading files that the Zscaler service
               is unable to scan.
        """
        if block_password_protected_archive_files is not None:
            pulumi.set(__self__, "block_password_protected_archive_files", block_password_protected_archive_files)
        if block_unscannable_files is not None:
            pulumi.set(__self__, "block_unscannable_files", block_unscannable_files)

    @property
    @pulumi.getter(name="blockPasswordProtectedArchiveFiles")
    def block_password_protected_archive_files(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        A Boolean value indicating whether to allow or block users from uploading or downloading password-protected files
        """
        return pulumi.get(self, "block_password_protected_archive_files")

    @block_password_protected_archive_files.setter
    def block_password_protected_archive_files(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "block_password_protected_archive_files", value)

    @property
    @pulumi.getter(name="blockUnscannableFiles")
    def block_unscannable_files(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        A Boolean value indicating whether to allow or block users from uploading or downloading files that the Zscaler service
        is unable to scan.
        """
        return pulumi.get(self, "block_unscannable_files")

    @block_unscannable_files.setter
    def block_unscannable_files(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "block_unscannable_files", value)


@pulumi.input_type
class _ATPMalwarePolicyState:
    def __init__(__self__, *,
                 block_password_protected_archive_files: Optional[pulumi.Input[builtins.bool]] = None,
                 block_unscannable_files: Optional[pulumi.Input[builtins.bool]] = None):
        """
        Input properties used for looking up and filtering ATPMalwarePolicy resources.
        :param pulumi.Input[builtins.bool] block_password_protected_archive_files: A Boolean value indicating whether to allow or block users from uploading or downloading password-protected files
        :param pulumi.Input[builtins.bool] block_unscannable_files: A Boolean value indicating whether to allow or block users from uploading or downloading files that the Zscaler service
               is unable to scan.
        """
        if block_password_protected_archive_files is not None:
            pulumi.set(__self__, "block_password_protected_archive_files", block_password_protected_archive_files)
        if block_unscannable_files is not None:
            pulumi.set(__self__, "block_unscannable_files", block_unscannable_files)

    @property
    @pulumi.getter(name="blockPasswordProtectedArchiveFiles")
    def block_password_protected_archive_files(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        A Boolean value indicating whether to allow or block users from uploading or downloading password-protected files
        """
        return pulumi.get(self, "block_password_protected_archive_files")

    @block_password_protected_archive_files.setter
    def block_password_protected_archive_files(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "block_password_protected_archive_files", value)

    @property
    @pulumi.getter(name="blockUnscannableFiles")
    def block_unscannable_files(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        A Boolean value indicating whether to allow or block users from uploading or downloading files that the Zscaler service
        is unable to scan.
        """
        return pulumi.get(self, "block_unscannable_files")

    @block_unscannable_files.setter
    def block_unscannable_files(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "block_unscannable_files", value)


@pulumi.type_token("zia:index/aTPMalwarePolicy:ATPMalwarePolicy")
class ATPMalwarePolicy(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 block_password_protected_archive_files: Optional[pulumi.Input[builtins.bool]] = None,
                 block_unscannable_files: Optional[pulumi.Input[builtins.bool]] = None,
                 __props__=None):
        """
        The **zia_atp_malware_policy** resource allows you to update security exceptions for the Malware Protection policy. To learn more see [Configuring Malware Protection Policy](https://help.zscaler.com/unified/configuring-malware-protection-policy)

        ## Example Usage

        ## Import

        Zscaler offers a dedicated tool called Zscaler-Terraformer to allow the automated import of ZIA configurations into Terraform-compliant HashiCorp Configuration Language.

        Visit

        **zia_atp_malware_policy** can be imported by using `policy` as the import ID.

        For example:

        ```sh
        $ pulumi import zia:index/aTPMalwarePolicy:ATPMalwarePolicy this "policy"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.bool] block_password_protected_archive_files: A Boolean value indicating whether to allow or block users from uploading or downloading password-protected files
        :param pulumi.Input[builtins.bool] block_unscannable_files: A Boolean value indicating whether to allow or block users from uploading or downloading files that the Zscaler service
               is unable to scan.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[ATPMalwarePolicyArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The **zia_atp_malware_policy** resource allows you to update security exceptions for the Malware Protection policy. To learn more see [Configuring Malware Protection Policy](https://help.zscaler.com/unified/configuring-malware-protection-policy)

        ## Example Usage

        ## Import

        Zscaler offers a dedicated tool called Zscaler-Terraformer to allow the automated import of ZIA configurations into Terraform-compliant HashiCorp Configuration Language.

        Visit

        **zia_atp_malware_policy** can be imported by using `policy` as the import ID.

        For example:

        ```sh
        $ pulumi import zia:index/aTPMalwarePolicy:ATPMalwarePolicy this "policy"
        ```

        :param str resource_name: The name of the resource.
        :param ATPMalwarePolicyArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ATPMalwarePolicyArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 block_password_protected_archive_files: Optional[pulumi.Input[builtins.bool]] = None,
                 block_unscannable_files: Optional[pulumi.Input[builtins.bool]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ATPMalwarePolicyArgs.__new__(ATPMalwarePolicyArgs)

            __props__.__dict__["block_password_protected_archive_files"] = block_password_protected_archive_files
            __props__.__dict__["block_unscannable_files"] = block_unscannable_files
        super(ATPMalwarePolicy, __self__).__init__(
            'zia:index/aTPMalwarePolicy:ATPMalwarePolicy',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            block_password_protected_archive_files: Optional[pulumi.Input[builtins.bool]] = None,
            block_unscannable_files: Optional[pulumi.Input[builtins.bool]] = None) -> 'ATPMalwarePolicy':
        """
        Get an existing ATPMalwarePolicy resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.bool] block_password_protected_archive_files: A Boolean value indicating whether to allow or block users from uploading or downloading password-protected files
        :param pulumi.Input[builtins.bool] block_unscannable_files: A Boolean value indicating whether to allow or block users from uploading or downloading files that the Zscaler service
               is unable to scan.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ATPMalwarePolicyState.__new__(_ATPMalwarePolicyState)

        __props__.__dict__["block_password_protected_archive_files"] = block_password_protected_archive_files
        __props__.__dict__["block_unscannable_files"] = block_unscannable_files
        return ATPMalwarePolicy(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="blockPasswordProtectedArchiveFiles")
    def block_password_protected_archive_files(self) -> pulumi.Output[builtins.bool]:
        """
        A Boolean value indicating whether to allow or block users from uploading or downloading password-protected files
        """
        return pulumi.get(self, "block_password_protected_archive_files")

    @property
    @pulumi.getter(name="blockUnscannableFiles")
    def block_unscannable_files(self) -> pulumi.Output[builtins.bool]:
        """
        A Boolean value indicating whether to allow or block users from uploading or downloading files that the Zscaler service
        is unable to scan.
        """
        return pulumi.get(self, "block_unscannable_files")

