# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = [
    'GetMalwareProtocolsResult',
    'AwaitableGetMalwareProtocolsResult',
    'get_malware_protocols',
    'get_malware_protocols_output',
]

@pulumi.output_type
class GetMalwareProtocolsResult:
    """
    A collection of values returned by getMalwareProtocols.
    """
    def __init__(__self__, id=None, inspect_ftp=None, inspect_ftp_over_http=None, inspect_http=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if inspect_ftp and not isinstance(inspect_ftp, bool):
            raise TypeError("Expected argument 'inspect_ftp' to be a bool")
        pulumi.set(__self__, "inspect_ftp", inspect_ftp)
        if inspect_ftp_over_http and not isinstance(inspect_ftp_over_http, bool):
            raise TypeError("Expected argument 'inspect_ftp_over_http' to be a bool")
        pulumi.set(__self__, "inspect_ftp_over_http", inspect_ftp_over_http)
        if inspect_http and not isinstance(inspect_http, bool):
            raise TypeError("Expected argument 'inspect_http' to be a bool")
        pulumi.set(__self__, "inspect_http", inspect_http)

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="inspectFtp")
    def inspect_ftp(self) -> builtins.bool:
        return pulumi.get(self, "inspect_ftp")

    @property
    @pulumi.getter(name="inspectFtpOverHttp")
    def inspect_ftp_over_http(self) -> builtins.bool:
        return pulumi.get(self, "inspect_ftp_over_http")

    @property
    @pulumi.getter(name="inspectHttp")
    def inspect_http(self) -> builtins.bool:
        return pulumi.get(self, "inspect_http")


class AwaitableGetMalwareProtocolsResult(GetMalwareProtocolsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetMalwareProtocolsResult(
            id=self.id,
            inspect_ftp=self.inspect_ftp,
            inspect_ftp_over_http=self.inspect_ftp_over_http,
            inspect_http=self.inspect_http)


def get_malware_protocols(opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetMalwareProtocolsResult:
    """
    Use the **zia_atp_malware_protocols** data source to retrieves the protocol inspection configurations for Malware Protection policy. To learn more see [Configuring Malware Protection Policy](https://help.zscaler.com/unified/configuring-malware-protection-policy)

    ## Example Usage
    """
    __args__ = dict()
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('zia:index/getMalwareProtocols:getMalwareProtocols', __args__, opts=opts, typ=GetMalwareProtocolsResult).value

    return AwaitableGetMalwareProtocolsResult(
        id=pulumi.get(__ret__, 'id'),
        inspect_ftp=pulumi.get(__ret__, 'inspect_ftp'),
        inspect_ftp_over_http=pulumi.get(__ret__, 'inspect_ftp_over_http'),
        inspect_http=pulumi.get(__ret__, 'inspect_http'))
def get_malware_protocols_output(opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetMalwareProtocolsResult]:
    """
    Use the **zia_atp_malware_protocols** data source to retrieves the protocol inspection configurations for Malware Protection policy. To learn more see [Configuring Malware Protection Policy](https://help.zscaler.com/unified/configuring-malware-protection-policy)

    ## Example Usage
    """
    __args__ = dict()
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('zia:index/getMalwareProtocols:getMalwareProtocols', __args__, opts=opts, typ=GetMalwareProtocolsResult)
    return __ret__.apply(lambda __response__: GetMalwareProtocolsResult(
        id=pulumi.get(__response__, 'id'),
        inspect_ftp=pulumi.get(__response__, 'inspect_ftp'),
        inspect_ftp_over_http=pulumi.get(__response__, 'inspect_ftp_over_http'),
        inspect_http=pulumi.get(__response__, 'inspect_http')))
